<html>
<head>
<title>OGRE: Ogre::QueuedRenderableCollection Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1QueuedRenderableCollection.html">QueuedRenderableCollection</a></div>
<h1>Ogre::QueuedRenderableCollection Class Reference</h1><!-- doxytag: class="Ogre::QueuedRenderableCollection" -->Lowest level collection of renderables.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreRenderQueueSortingGrouping_8h-source.html">OgreRenderQueueSortingGrouping.h</a>&gt;</code>
<p>

<p>
<a href="classOgre_1_1QueuedRenderableCollection-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Types</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">enum &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#b44ba16fe8e8c0247234d4e6edfae844">OrganisationMode</a> { <a class="el" href="classOgre_1_1QueuedRenderableCollection.html#b44ba16fe8e8c0247234d4e6edfae8445cb7861265877a6f1f0a4b3508df7014">OM_PASS_GROUP</a> =  1, 
<a class="el" href="classOgre_1_1QueuedRenderableCollection.html#b44ba16fe8e8c0247234d4e6edfae844aec5c102c9894feda331832a82738d72">OM_SORT_DESCENDING</a> =  2, 
<a class="el" href="classOgre_1_1QueuedRenderableCollection.html#b44ba16fe8e8c0247234d4e6edfae8442cb722796eba6d25f8f7e8d7a4738241">OM_SORT_ASCENDING</a> =  6
 }</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Organisation modes required for this collection.  <a href="classOgre_1_1QueuedRenderableCollection.html#b44ba16fe8e8c0247234d4e6edfae844">More...</a><br></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#ef05cc3a16e4f6a83c2cbd8b4bec377b">QueuedRenderableCollection</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#46521c1079d0916430d29cc15900ec95">~QueuedRenderableCollection</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#e211c3c1661e84dc6c14c97c0ec26dc5">clear</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Empty the collection.  <a href="#e211c3c1661e84dc6c14c97c0ec26dc5"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#bc5558898bde744ffebf36421b7c9d9e">removePassGroup</a> (<a class="el" href="classOgre_1_1Pass.html">Pass</a> *p)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Remove the group entry (if any) for a given <a class="el" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>.  <a href="#bc5558898bde744ffebf36421b7c9d9e"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#fde7f8e139270c04158880ea90da71a0">resetOrganisationModes</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Reset the organisation modes required for this collection.  <a href="#fde7f8e139270c04158880ea90da71a0"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#1f30f771db3b5dd9f520a3e17ff9e1bb">addOrganisationMode</a> (<a class="el" href="classOgre_1_1QueuedRenderableCollection.html#b44ba16fe8e8c0247234d4e6edfae844">OrganisationMode</a> om)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Add a required sorting / grouping mode to this collection when next used.  <a href="#1f30f771db3b5dd9f520a3e17ff9e1bb"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#a6dfdb7b4aefd87f8446651846d00e8c">addRenderable</a> (<a class="el" href="classOgre_1_1Pass.html">Pass</a> *pass, <a class="el" href="classOgre_1_1Renderable.html">Renderable</a> *rend)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Add a renderable to the collection using a given pass.  <a href="#a6dfdb7b4aefd87f8446651846d00e8c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#ed4bb7796c9730f96dbd1197c97af40b">sort</a> (const <a class="el" href="classOgre_1_1Camera.html">Camera</a> *cam)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Perform any sorting that is required on this collection.  <a href="#ed4bb7796c9730f96dbd1197c97af40b"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#9c83871d9b27e91a83900d4f5835879c">acceptVisitor</a> (<a class="el" href="classOgre_1_1QueuedRenderableVisitor.html">QueuedRenderableVisitor</a> *visitor, <a class="el" href="classOgre_1_1QueuedRenderableCollection.html#b44ba16fe8e8c0247234d4e6edfae844">OrganisationMode</a> om) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Accept a visitor over the collection contents.  <a href="#9c83871d9b27e91a83900d4f5835879c"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Types</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::vector<br>
&lt; <a class="el" href="structOgre_1_1RenderablePass.html">RenderablePass</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#d820db5042693a75be0267bbe018869e">RenderablePassList</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Vector of <a class="el" href="structOgre_1_1RenderablePass.html" title="Struct associating a single Pass with a single Renderable.">RenderablePass</a> objects, this is built on the assumption that vectors only ever increase in size, so even if we do <a class="el" href="classOgre_1_1QueuedRenderableCollection.html#e211c3c1661e84dc6c14c97c0ec26dc5" title="Empty the collection.">clear()</a> the memory stays allocated, ie fast.  <a href="#d820db5042693a75be0267bbe018869e"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::vector<br>
&lt; <a class="el" href="classOgre_1_1Renderable.html">Renderable</a> * &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#8d0649f312e57548ccd021337e3c56bd">RenderableList</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::map<br>
&lt; <a class="el" href="classOgre_1_1Pass.html">Pass</a> *,<br>
 <a class="el" href="classOgre_1_1QueuedRenderableCollection.html#8d0649f312e57548ccd021337e3c56bd">RenderableList</a> *,<br>
 <a class="el" href="structOgre_1_1QueuedRenderableCollection_1_1PassGroupLess.html">PassGroupLess</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#7860489c24be0b6e45308b5e6dda8b64">PassGroupRenderableMap</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Map of pass to renderable lists, this is a grouping by pass.  <a href="#7860489c24be0b6e45308b5e6dda8b64"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#07ea37d2e24138cff538fd97224f2011">acceptVisitorGrouped</a> (<a class="el" href="classOgre_1_1QueuedRenderableVisitor.html">QueuedRenderableVisitor</a> *visitor) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal visitor implementation.  <a href="#07ea37d2e24138cff538fd97224f2011"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#6cad91544a5a489e0ffab7ffb46a369b">acceptVisitorDescending</a> (<a class="el" href="classOgre_1_1QueuedRenderableVisitor.html">QueuedRenderableVisitor</a> *visitor) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal visitor implementation.  <a href="#6cad91544a5a489e0ffab7ffb46a369b"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#2bbcfb0e914241932fef6db9f8c163ab">acceptVisitorAscending</a> (<a class="el" href="classOgre_1_1QueuedRenderableVisitor.html">QueuedRenderableVisitor</a> *visitor) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal visitor implementation.  <a href="#2bbcfb0e914241932fef6db9f8c163ab"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#e9a31d2cd0e88ce11ba006d04cb7ac0d">mOrganisationMode</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Bitmask of the organisation modes requested.  <a href="#e9a31d2cd0e88ce11ba006d04cb7ac0d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#7860489c24be0b6e45308b5e6dda8b64">PassGroupRenderableMap</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#3b34af9f4be41db1386d479720ce602e">mGrouped</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Grouped.  <a href="#3b34af9f4be41db1386d479720ce602e"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#d820db5042693a75be0267bbe018869e">RenderablePassList</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#b800c1e93b112978e82e22f00046e3d1">mSortedDescending</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sorted descending (can iterate backwards to get ascending).  <a href="#b800c1e93b112978e82e22f00046e3d1"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Static Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static <a class="el" href="classOgre_1_1RadixSort.html">RadixSort</a><br>
&lt; <a class="el" href="classOgre_1_1QueuedRenderableCollection.html#d820db5042693a75be0267bbe018869e">RenderablePassList</a>,<br>
 <a class="el" href="structOgre_1_1RenderablePass.html">RenderablePass</a>,<br>
 <a class="el" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#760cf336631fb24e6f6cc2fb45c850a1">msRadixSorter1</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Radix sorter for accessing sort value 1 (<a class="el" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>).  <a href="#760cf336631fb24e6f6cc2fb45c850a1"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static <a class="el" href="classOgre_1_1RadixSort.html">RadixSort</a><br>
&lt; <a class="el" href="classOgre_1_1QueuedRenderableCollection.html#d820db5042693a75be0267bbe018869e">RenderablePassList</a>,<br>
 <a class="el" href="structOgre_1_1RenderablePass.html">RenderablePass</a>,<br>
 float &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#c4c356244366d78dccbc80a3125c4d36">msRadixSorter2</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Radix sorter for sort value 2 (distance).  <a href="#c4c356244366d78dccbc80a3125c4d36"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Classes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1QueuedRenderableCollection_1_1DepthSortDescendingLess.html">DepthSortDescendingLess</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Comparator to order objects by descending camera distance.  <a href="structOgre_1_1QueuedRenderableCollection_1_1DepthSortDescendingLess.html#_details">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1QueuedRenderableCollection_1_1PassGroupLess.html">PassGroupLess</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Comparator to order pass groups.  <a href="structOgre_1_1QueuedRenderableCollection_1_1PassGroupLess.html#_details">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1QueuedRenderableCollection_1_1RadixSortFunctorDistance.html">RadixSortFunctorDistance</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Functor for descending sort value 2 for radix sort (distance).  <a href="structOgre_1_1QueuedRenderableCollection_1_1RadixSortFunctorDistance.html#_details">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1QueuedRenderableCollection_1_1RadixSortFunctorPass.html">RadixSortFunctorPass</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Functor for accessing sort value 1 for radix sort (<a class="el" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>).  <a href="structOgre_1_1QueuedRenderableCollection_1_1RadixSortFunctorPass.html#_details">More...</a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Lowest level collection of renderables. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>To iterate over items in this collection, you must call the accept method and supply a <a class="el" href="classOgre_1_1QueuedRenderableVisitor.html" title="Visitor interface for items in a QueuedRenderableCollection.">QueuedRenderableVisitor</a>. The order of the iteration, and whether that iteration is over a <a class="el" href="structOgre_1_1RenderablePass.html" title="Struct associating a single Pass with a single Renderable.">RenderablePass</a> list or a 2-level grouped list which causes a visit call at the <a class="el" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a> level, and a call for each <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> underneath. </dd></dl>

<p>Definition at line <a class="el" href="OgreRenderQueueSortingGrouping_8h-source.html#l00108">108</a> of file <a class="el" href="OgreRenderQueueSortingGrouping_8h-source.html">OgreRenderQueueSortingGrouping.h</a>.</p>
<hr><h2>Member Typedef Documentation</h2>
<a class="anchor" name="d820db5042693a75be0267bbe018869e"></a><!-- doxytag: member="Ogre::QueuedRenderableCollection::RenderablePassList" ref="d820db5042693a75be0267bbe018869e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;<a class="el" href="structOgre_1_1RenderablePass.html">RenderablePass</a>&gt; <a class="el" href="classOgre_1_1QueuedRenderableCollection.html#d820db5042693a75be0267bbe018869e">Ogre::QueuedRenderableCollection::RenderablePassList</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Vector of <a class="el" href="structOgre_1_1RenderablePass.html" title="Struct associating a single Pass with a single Renderable.">RenderablePass</a> objects, this is built on the assumption that vectors only ever increase in size, so even if we do <a class="el" href="classOgre_1_1QueuedRenderableCollection.html#e211c3c1661e84dc6c14c97c0ec26dc5" title="Empty the collection.">clear()</a> the memory stays allocated, ie fast. 
<p>

<p>Definition at line <a class="el" href="OgreRenderQueueSortingGrouping_8h-source.html#l00191">191</a> of file <a class="el" href="OgreRenderQueueSortingGrouping_8h-source.html">OgreRenderQueueSortingGrouping.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="8d0649f312e57548ccd021337e3c56bd"></a><!-- doxytag: member="Ogre::QueuedRenderableCollection::RenderableList" ref="8d0649f312e57548ccd021337e3c56bd" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;<a class="el" href="classOgre_1_1Renderable.html">Renderable</a>*&gt; <a class="el" href="classOgre_1_1QueuedRenderableCollection.html#8d0649f312e57548ccd021337e3c56bd">Ogre::QueuedRenderableCollection::RenderableList</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreRenderQueueSortingGrouping_8h-source.html#l00192">192</a> of file <a class="el" href="OgreRenderQueueSortingGrouping_8h-source.html">OgreRenderQueueSortingGrouping.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="7860489c24be0b6e45308b5e6dda8b64"></a><!-- doxytag: member="Ogre::QueuedRenderableCollection::PassGroupRenderableMap" ref="7860489c24be0b6e45308b5e6dda8b64" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::map&lt;<a class="el" href="classOgre_1_1Pass.html">Pass</a>*, <a class="el" href="classOgre_1_1QueuedRenderableCollection.html#8d0649f312e57548ccd021337e3c56bd">RenderableList</a>*, <a class="el" href="structOgre_1_1QueuedRenderableCollection_1_1PassGroupLess.html">PassGroupLess</a>&gt; <a class="el" href="classOgre_1_1QueuedRenderableCollection.html#7860489c24be0b6e45308b5e6dda8b64">Ogre::QueuedRenderableCollection::PassGroupRenderableMap</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Map of pass to renderable lists, this is a grouping by pass. 
<p>

<p>Definition at line <a class="el" href="OgreRenderQueueSortingGrouping_8h-source.html#l00194">194</a> of file <a class="el" href="OgreRenderQueueSortingGrouping_8h-source.html">OgreRenderQueueSortingGrouping.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Enumeration Documentation</h2>
<a class="anchor" name="b44ba16fe8e8c0247234d4e6edfae844"></a><!-- doxytag: member="Ogre::QueuedRenderableCollection::OrganisationMode" ref="b44ba16fe8e8c0247234d4e6edfae844" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="classOgre_1_1QueuedRenderableCollection.html#b44ba16fe8e8c0247234d4e6edfae844">Ogre::QueuedRenderableCollection::OrganisationMode</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Organisation modes required for this collection. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This affects the internal placement of the items added to this collection; if only one type of sorting / grouping is to be required, then renderables can be stored only once, whilst if multiple types are going to be needed then internally there will be multiple organisations. Changing the organisation needs to be done when the collection is empty. </dd></dl>
<dl compact><dt><b>Enumerator: </b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td valign="top"><em><a class="anchor" name="b44ba16fe8e8c0247234d4e6edfae8445cb7861265877a6f1f0a4b3508df7014"></a><!-- doxytag: member="OM_PASS_GROUP" ref="b44ba16fe8e8c0247234d4e6edfae8445cb7861265877a6f1f0a4b3508df7014" args="" -->OM_PASS_GROUP</em>&nbsp;</td><td>
Group by pass. </td></tr>
<tr><td valign="top"><em><a class="anchor" name="b44ba16fe8e8c0247234d4e6edfae844aec5c102c9894feda331832a82738d72"></a><!-- doxytag: member="OM_SORT_DESCENDING" ref="b44ba16fe8e8c0247234d4e6edfae844aec5c102c9894feda331832a82738d72" args="" -->OM_SORT_DESCENDING</em>&nbsp;</td><td>
Sort descending camera distance. </td></tr>
<tr><td valign="top"><em><a class="anchor" name="b44ba16fe8e8c0247234d4e6edfae8442cb722796eba6d25f8f7e8d7a4738241"></a><!-- doxytag: member="OM_SORT_ASCENDING" ref="b44ba16fe8e8c0247234d4e6edfae8442cb722796eba6d25f8f7e8d7a4738241" args="" -->OM_SORT_ASCENDING</em>&nbsp;</td><td>
Sort ascending camera distance Note value overlaps with descending since both use same sort. </td></tr>
</table>
</dl>

<p>Definition at line <a class="el" href="OgreRenderQueueSortingGrouping_8h-source.html#l00119">119</a> of file <a class="el" href="OgreRenderQueueSortingGrouping_8h-source.html">OgreRenderQueueSortingGrouping.h</a>.</p>

</div>
</div><p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="ef05cc3a16e4f6a83c2cbd8b4bec377b"></a><!-- doxytag: member="Ogre::QueuedRenderableCollection::QueuedRenderableCollection" ref="ef05cc3a16e4f6a83c2cbd8b4bec377b" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::QueuedRenderableCollection::QueuedRenderableCollection           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="46521c1079d0916430d29cc15900ec95"></a><!-- doxytag: member="Ogre::QueuedRenderableCollection::~QueuedRenderableCollection" ref="46521c1079d0916430d29cc15900ec95" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::QueuedRenderableCollection::~QueuedRenderableCollection           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="07ea37d2e24138cff538fd97224f2011"></a><!-- doxytag: member="Ogre::QueuedRenderableCollection::acceptVisitorGrouped" ref="07ea37d2e24138cff538fd97224f2011" args="(QueuedRenderableVisitor *visitor) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::QueuedRenderableCollection::acceptVisitorGrouped           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1QueuedRenderableVisitor.html">QueuedRenderableVisitor</a> *&nbsp;</td>
          <td class="paramname"> <em>visitor</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal visitor implementation. 
<p>

</div>
</div><p>
<a class="anchor" name="6cad91544a5a489e0ffab7ffb46a369b"></a><!-- doxytag: member="Ogre::QueuedRenderableCollection::acceptVisitorDescending" ref="6cad91544a5a489e0ffab7ffb46a369b" args="(QueuedRenderableVisitor *visitor) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::QueuedRenderableCollection::acceptVisitorDescending           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1QueuedRenderableVisitor.html">QueuedRenderableVisitor</a> *&nbsp;</td>
          <td class="paramname"> <em>visitor</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal visitor implementation. 
<p>

</div>
</div><p>
<a class="anchor" name="2bbcfb0e914241932fef6db9f8c163ab"></a><!-- doxytag: member="Ogre::QueuedRenderableCollection::acceptVisitorAscending" ref="2bbcfb0e914241932fef6db9f8c163ab" args="(QueuedRenderableVisitor *visitor) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::QueuedRenderableCollection::acceptVisitorAscending           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1QueuedRenderableVisitor.html">QueuedRenderableVisitor</a> *&nbsp;</td>
          <td class="paramname"> <em>visitor</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Internal visitor implementation. 
<p>

</div>
</div><p>
<a class="anchor" name="e211c3c1661e84dc6c14c97c0ec26dc5"></a><!-- doxytag: member="Ogre::QueuedRenderableCollection::clear" ref="e211c3c1661e84dc6c14c97c0ec26dc5" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::QueuedRenderableCollection::clear           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Empty the collection. 
<p>

</div>
</div><p>
<a class="anchor" name="bc5558898bde744ffebf36421b7c9d9e"></a><!-- doxytag: member="Ogre::QueuedRenderableCollection::removePassGroup" ref="bc5558898bde744ffebf36421b7c9d9e" args="(Pass *p)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::QueuedRenderableCollection::removePassGroup           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Pass.html">Pass</a> *&nbsp;</td>
          <td class="paramname"> <em>p</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Remove the group entry (if any) for a given <a class="el" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>To be used when a pass is destroyed, such that any grouping level for it becomes useless. </dd></dl>

</div>
</div><p>
<a class="anchor" name="fde7f8e139270c04158880ea90da71a0"></a><!-- doxytag: member="Ogre::QueuedRenderableCollection::resetOrganisationModes" ref="fde7f8e139270c04158880ea90da71a0" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::QueuedRenderableCollection::resetOrganisationModes           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Reset the organisation modes required for this collection. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>You can only do this when the collection is empty. </dd></dl>
<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#b44ba16fe8e8c0247234d4e6edfae844" title="Organisation modes required for this collection.">OrganisationMode</a> </dd></dl>

<p>Definition at line <a class="el" href="OgreRenderQueueSortingGrouping_8h-source.html#l00263">263</a> of file <a class="el" href="OgreRenderQueueSortingGrouping_8h-source.html">OgreRenderQueueSortingGrouping.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="1f30f771db3b5dd9f520a3e17ff9e1bb"></a><!-- doxytag: member="Ogre::QueuedRenderableCollection::addOrganisationMode" ref="1f30f771db3b5dd9f520a3e17ff9e1bb" args="(OrganisationMode om)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::QueuedRenderableCollection::addOrganisationMode           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#b44ba16fe8e8c0247234d4e6edfae844">OrganisationMode</a>&nbsp;</td>
          <td class="paramname"> <em>om</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Add a required sorting / grouping mode to this collection when next used. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>You can only do this when the collection is empty. </dd></dl>
<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#b44ba16fe8e8c0247234d4e6edfae844" title="Organisation modes required for this collection.">OrganisationMode</a> </dd></dl>

<p>Definition at line <a class="el" href="OgreRenderQueueSortingGrouping_8h-source.html#l00273">273</a> of file <a class="el" href="OgreRenderQueueSortingGrouping_8h-source.html">OgreRenderQueueSortingGrouping.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="a6dfdb7b4aefd87f8446651846d00e8c"></a><!-- doxytag: member="Ogre::QueuedRenderableCollection::addRenderable" ref="a6dfdb7b4aefd87f8446651846d00e8c" args="(Pass *pass, Renderable *rend)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::QueuedRenderableCollection::addRenderable           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Pass.html">Pass</a> *&nbsp;</td>
          <td class="paramname"> <em>pass</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Renderable.html">Renderable</a> *&nbsp;</td>
          <td class="paramname"> <em>rend</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Add a renderable to the collection using a given pass. 
<p>

</div>
</div><p>
<a class="anchor" name="ed4bb7796c9730f96dbd1197c97af40b"></a><!-- doxytag: member="Ogre::QueuedRenderableCollection::sort" ref="ed4bb7796c9730f96dbd1197c97af40b" args="(const Camera *cam)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::QueuedRenderableCollection::sort           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Camera.html">Camera</a> *&nbsp;</td>
          <td class="paramname"> <em>cam</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Perform any sorting that is required on this collection. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>cam</em>&nbsp;</td><td>The camera </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="9c83871d9b27e91a83900d4f5835879c"></a><!-- doxytag: member="Ogre::QueuedRenderableCollection::acceptVisitor" ref="9c83871d9b27e91a83900d4f5835879c" args="(QueuedRenderableVisitor *visitor, OrganisationMode om) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::QueuedRenderableCollection::acceptVisitor           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1QueuedRenderableVisitor.html">QueuedRenderableVisitor</a> *&nbsp;</td>
          <td class="paramname"> <em>visitor</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#b44ba16fe8e8c0247234d4e6edfae844">OrganisationMode</a>&nbsp;</td>
          <td class="paramname"> <em>om</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Accept a visitor over the collection contents. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>visitor</em>&nbsp;</td><td>Visitor class which should be called back </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>om</em>&nbsp;</td><td>The organisation mode which you want to iterate over. Note that this must have been included in an addOrganisationMode call before any renderables were added. </td></tr>
  </table>
</dl>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="760cf336631fb24e6f6cc2fb45c850a1"></a><!-- doxytag: member="Ogre::QueuedRenderableCollection::msRadixSorter1" ref="760cf336631fb24e6f6cc2fb45c850a1" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RadixSort.html">RadixSort</a>&lt;<a class="el" href="classOgre_1_1QueuedRenderableCollection.html#d820db5042693a75be0267bbe018869e">RenderablePassList</a>, <a class="el" href="structOgre_1_1RenderablePass.html">RenderablePass</a>, <a class="el" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a>&gt; <a class="el" href="classOgre_1_1QueuedRenderableCollection.html#760cf336631fb24e6f6cc2fb45c850a1">Ogre::QueuedRenderableCollection::msRadixSorter1</a><code> [static, protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Radix sorter for accessing sort value 1 (<a class="el" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>). 
<p>

<p>Definition at line <a class="el" href="OgreRenderQueueSortingGrouping_8h-source.html#l00206">206</a> of file <a class="el" href="OgreRenderQueueSortingGrouping_8h-source.html">OgreRenderQueueSortingGrouping.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="c4c356244366d78dccbc80a3125c4d36"></a><!-- doxytag: member="Ogre::QueuedRenderableCollection::msRadixSorter2" ref="c4c356244366d78dccbc80a3125c4d36" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RadixSort.html">RadixSort</a>&lt;<a class="el" href="classOgre_1_1QueuedRenderableCollection.html#d820db5042693a75be0267bbe018869e">RenderablePassList</a>, <a class="el" href="structOgre_1_1RenderablePass.html">RenderablePass</a>, float&gt; <a class="el" href="classOgre_1_1QueuedRenderableCollection.html#c4c356244366d78dccbc80a3125c4d36">Ogre::QueuedRenderableCollection::msRadixSorter2</a><code> [static, protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Radix sorter for sort value 2 (distance). 
<p>

<p>Definition at line <a class="el" href="OgreRenderQueueSortingGrouping_8h-source.html#l00227">227</a> of file <a class="el" href="OgreRenderQueueSortingGrouping_8h-source.html">OgreRenderQueueSortingGrouping.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="e9a31d2cd0e88ce11ba006d04cb7ac0d"></a><!-- doxytag: member="Ogre::QueuedRenderableCollection::mOrganisationMode" ref="e9a31d2cd0e88ce11ba006d04cb7ac0d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <a class="el" href="classOgre_1_1QueuedRenderableCollection.html#e9a31d2cd0e88ce11ba006d04cb7ac0d">Ogre::QueuedRenderableCollection::mOrganisationMode</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Bitmask of the organisation modes requested. 
<p>

<p>Definition at line <a class="el" href="OgreRenderQueueSortingGrouping_8h-source.html#l00230">230</a> of file <a class="el" href="OgreRenderQueueSortingGrouping_8h-source.html">OgreRenderQueueSortingGrouping.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="3b34af9f4be41db1386d479720ce602e"></a><!-- doxytag: member="Ogre::QueuedRenderableCollection::mGrouped" ref="3b34af9f4be41db1386d479720ce602e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#7860489c24be0b6e45308b5e6dda8b64">PassGroupRenderableMap</a> <a class="el" href="classOgre_1_1QueuedRenderableCollection.html#3b34af9f4be41db1386d479720ce602e">Ogre::QueuedRenderableCollection::mGrouped</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Grouped. 
<p>

<p>Definition at line <a class="el" href="OgreRenderQueueSortingGrouping_8h-source.html#l00233">233</a> of file <a class="el" href="OgreRenderQueueSortingGrouping_8h-source.html">OgreRenderQueueSortingGrouping.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="b800c1e93b112978e82e22f00046e3d1"></a><!-- doxytag: member="Ogre::QueuedRenderableCollection::mSortedDescending" ref="b800c1e93b112978e82e22f00046e3d1" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1QueuedRenderableCollection.html#d820db5042693a75be0267bbe018869e">RenderablePassList</a> <a class="el" href="classOgre_1_1QueuedRenderableCollection.html#b800c1e93b112978e82e22f00046e3d1">Ogre::QueuedRenderableCollection::mSortedDescending</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Sorted descending (can iterate backwards to get ascending). 
<p>

<p>Definition at line <a class="el" href="OgreRenderQueueSortingGrouping_8h-source.html#l00235">235</a> of file <a class="el" href="OgreRenderQueueSortingGrouping_8h-source.html">OgreRenderQueueSortingGrouping.h</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreRenderQueueSortingGrouping_8h-source.html">OgreRenderQueueSortingGrouping.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:52:07 2008
</p>
</body>
</html>
